Subject: Re: [PATCH 1/2] submodule.c: add has_submodules to check if we have any submodules

From: Brandon Williams <[email-masked]>
Date: Thu, 20 Apr 2017 15:25:10 -0700

On 04/20, Stefan Beller wrote:
> On Thu, Apr 20, 2017 at 3:07 PM, Brandon Williams <[email-masked]> wrote:
> > On 04/11, Stefan Beller wrote:
> >> +int has_submodules(unsigned what_to_check)
> >> +{
> >> +     if (what_to_check & SUBMODULE_CHECK_ANY_CONFIG) {
> >> +             if (submodule_config_reading == SUBMODULE_CONFIG_NOT_READ)
> >> +                     load_submodule_config();
> >> +             if (submodule_config_reading == SUBMODULE_CONFIG_EXISTS)
> >> +                     return 1;
> >> +     }
> >> +
> >> +     if ((what_to_check & SUBMODULE_CHECK_ABSORBED_GIT_DIRS) &&
> >> +         file_exists(git_path("modules")))
> >> +             return 1;
> >> +
> >> +     if ((what_to_check & SUBMODULE_CHECK_GITMODULES_IN_WT) &&
> >> +         (!is_bare_repository() && file_exists(".gitmodules")))
> >> +             return 1;
> >> +
> >> +     if (what_to_check & SUBMODULE_CHECK_GITLINKS_IN_TREE) {
> >> +             int i;
> >> +
> >> +             if (read_cache() < 0)
> >> +                     die(_("index file corrupt"));
> >> +
> >> +             for (i = 0; i < active_nr; i++)
> >> +                     if (S_ISGITLINK(active_cache[i]->ce_mode))
> >> +                             return 1;
> >> +     }
> >> +
> >> +     return 0;
> >> +}
> >
> > It may be a good idea to rearrange these by order to correctness.
> 
> I arranged by estimated speed, i.e. from fastest to slowest:
> * The first check just returns a value from memory in the standard case
>   Though the first one may take a hit in performance for the very first time
>   as it may need to load the config.
> * The next two are an actual stat system call, each having a different
>   'defect'. (We may have non-absorbed submodules or non-bare repos)
>   -> We could have a check for in-tree as well, not sure if that is desired.

Fair enough, I'm fine with the ordering then.

> 
> > Correctness may not be the best way to describe it, but which is the
> > strongest indicator that there is a submodule or that a repo 'has a
> > submodule'.
> 
> These indicators differ in strength for different scenarios IMO.
> (Just after clone: check for a .gitmodules file instead of a config;
> later: rather check for a config as it is fastest and actually catches
> active submodules; maybe we do not care about inactive submodules)

This is why I went back on my thinking :)  I realized that it really
depends on the scenario you are in.

> 
> >  That way in the future we could have a #define that is
> > SUBMODULE_CHECK_ANY or ALL or something....Now that I'm thinking harder
> > about that we may not want that, and just require explicitly stating
> > which check you want done.
> >
> > Anyways good looking patch, and I like the idea of consolidating the
> > checks into a single function.
> 
> Thanks,
> Stefan

-- 
Brandon Williams